From c4570c271d54228f709a8ef65871a7481642d48f Mon Sep 17 00:00:00 2001
From: Nils Philippsen <nils@redhat.com>
Date: Jan 18 2018 16:36:31 +0000
Subject: [PATCH 36/48] migrate ModuleBuildopts* to TreeObj


---

diff --git a/modulemd/buildopts/__init__.py b/modulemd/buildopts/__init__.py
index b92c9fd..9e7e06f 100644
--- a/modulemd/buildopts/__init__.py
+++ b/modulemd/buildopts/__init__.py
@@ -22,18 +22,24 @@
 #
 # Written by Petr Šabata <contyk@redhat.com>
 
+from ..legacy_wrappers import TreeObj
+
 from .rpms import ModuleBuildoptsRPMs
 
-supported_content = ("rpms",)
 
-class ModuleBuildopts(object):
+supported_content = ('rpms',)
+
+
+class ModuleBuildopts(TreeObj):
     """Class representing component build options."""
 
-    def __init__(self, parent=None):
-        """Creates a new ModuleBuildopts instance."""
-        self.rpms = ModuleBuildoptsRPMs(parent=parent)
-        self.parent = parent
+    tree_props = ('rpms',)
+    tree_identity = 'buildopts'
 
+    def __init__(self, rpms=None, parent=None):
+        """Creates a new ModuleBuildopts instance."""
+        super(ModuleBuildopts, self).__init__(parent=parent)
+        self._rpms = ModuleBuildoptsRPMs(parent=parent)
 
     def __repr__(self):
         return "<ModuleBuildopts: rpms: {!r}>".format(self.rpms)
@@ -54,9 +60,8 @@ class ModuleBuildopts(object):
     def rpms(self, o):
         if not isinstance(o, ModuleBuildoptsRPMs):
             raise TypeError("buildopts.rpms: data type not supported")
-        self._rpms = o
 
-        if hasattr(self, 'parent') and self.parent is not None:
-            opts = dict()
-            opts['macros'] = o.macros
-            self.parent.set_buildopts(opts)
+        if self.parent:
+            self._rpms.replace(o)
+        else:
+            self._rpms = o
diff --git a/modulemd/buildopts/base.py b/modulemd/buildopts/base.py
index 870e6c9..f82ac7e 100644
--- a/modulemd/buildopts/base.py
+++ b/modulemd/buildopts/base.py
@@ -22,12 +22,13 @@
 #
 # Written by Petr Šabata <contyk@redhat.com>
 
+from ..legacy_wrappers import TreeObj
 
-class ModuleBuildoptsBase(object):
-    """A base class for definining component build options."""
 
-    def __init__(self):
-        """Creates a new ModuleBuildoptsBase instance."""
+class ModuleBuildoptsBase(TreeObj):
+    """A base class for defining component build options.
+
+    Nobody knows why it exists."""
 
     def __repr__(self):
         return ("<ModuleBuildoptsBase>")
diff --git a/modulemd/buildopts/rpms.py b/modulemd/buildopts/rpms.py
index d601d1e..2ca97f7 100644
--- a/modulemd/buildopts/rpms.py
+++ b/modulemd/buildopts/rpms.py
@@ -30,24 +30,9 @@ class ModuleBuildoptsRPMs(ModuleBuildoptsBase):
 
     def __init__(self, macros="", parent=None):
         """Creates a new ModuleBuildoptsRPMs instance."""
-        super(ModuleBuildoptsRPMs, self).__init__()
-        self.macros = macros
-        self.parent = parent
-
-        # If macros were specified at initialization, update the
-        # module with it
-        if self.macros:
-            if hasattr(self, 'parent'):
-                opts = dict()
-                opts['macros'] = self.macros
-                self.parent.module.set_rpm_buildopts(opts)
-            return
-
-        if parent:
-            m = self.parent.module.get_rpm_buildopts()
-            if 'macros' in m:
-                self.macros = m['macros']
+        super(ModuleBuildoptsRPMs, self).__init__(parent=parent)
 
+        self.macros = macros
 
     def __repr__(self):
         return "<ModuleBuildoptsRPMs: macros: {!r}>".format(self.macros)
@@ -62,15 +47,23 @@ class ModuleBuildoptsRPMs(ModuleBuildoptsBase):
         """A string property representing the additional RPM macros that
         should be used for this module build.
         """
-        return self._macros
+        if self.parent:
+            rpm_buildopts = self.parent.module.get_rpm_buildopts()
+            if rpm_buildopts:
+                return rpm_buildopts['macros']
+            else:
+                return ""
+        else:
+            return self._macros
 
     @macros.setter
     def macros(self, s):
         if not isinstance(s, str):
             raise TypeError("buildoptsrpm.macros: data type not supported")
-        self._macros = s
 
-        if hasattr(self, 'parent') and self.parent is not None:
+        if self.parent:
             opts = dict()
-            opts['macros'] = self.macros
+            opts['macros'] = s
             self.parent.module.set_rpm_buildopts(opts)
+        else:
+            self._macros = s

